﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Media;

namespace BeeCoders.Tools.ControlCanvas.Adorners
{
    public class ResizeAdorner : Adorner
    {
        private readonly VisualCollection visuals;
        private readonly ResizeChrome chrome;

        protected override int VisualChildrenCount
        {
            get
            {
                return visuals.Count;
            }
        }

        public ResizeAdorner(ContentControl designerItem)
            : base(designerItem)
        {
            chrome = new ResizeChrome();
            visuals = new VisualCollection(this) {chrome};
            chrome.DataContext = designerItem;
        }

        protected override Size ArrangeOverride(Size arrangeBounds)
        {
            chrome.Arrange(new Rect(arrangeBounds));
            return arrangeBounds;
        }

        protected override Visual GetVisualChild(int index)
        {
            return visuals[index];
        }
    }
}
